//	+---------------------------+
//	|	Gun Plus				|
//	|	Version 2.0				|
//	|	By Zapk - 12270			|
//	+---------------------------+

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)	exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Max Clip Ammo","Gun+","Pref::GunPlus::MaxClipAmmo","int 1 10","Weapon_GunPlus",5,0,0);
	RTB_registerPref("Play Distant Sound","Gun+","Pref::GunPlus::PlayDistantSound","bool","Weapon_GunPlus",1,0,0);
	RTB_registerPref("Fire Recoil","Gun+","Pref::GunPlus::DoRecoil","bool","Weapon_GunPlus",1,0,0);
}
else
{
	$Pref::GunPlus::MaxClipAmmo = 5;
	$Pref::GunPlus::PlayDistantSound = true;
	$Pref::GunPlus::DoRecoil = true;
}

//audio
datablock AudioProfile(GunPlusFireSound)
{
	filename	 = "./gunShot1.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(GunPlusBulletHitSound : GunPlusFireSound)
{
	filename	 = "./bulletHit.wav";
};
datablock AudioProfile(GunPlusReloadSound : GunPlusFireSound)
{
	filename	= "./gunReload1.wav";
};
datablock AudioProfile(GunPlusEmptyClip : GunPlusFireSound)
{
	filename	 = "./emptyClip.wav";
};
datablock AudioProfile(GunPlusDistantFire : GunPlusFireSound)
{
	filename	 = "./gunDistant.wav";
};

datablock ExplosionData(gunPlusExplosion : gunExplosion)
{
	soundProfile = GunPlusBulletHitSound;
};

datablock ProjectileData(GunPlusProjectile : gunProjectile)
{
	projectileShapeName = "./bullet.dts";
	explosion			  = GunPlusExplosion;
	uiName = "Gun+ Bullet";
};

datablock ItemData(GunPlusItem : GunItem)
{
	shapeFile = "./pistol.dts";
	uiName = "Gun+";
	image = GunPlusImage;
};

datablock ShapeBaseImageData(GunPlusImage : gunImage)
{
	shapeFile = "./pistol.dts";
	projectile = GunPlusProjectile;
	
	stateName[0]							= "Activate";
	stateTimeoutValue[0]				 = 0.15;
	stateTransitionOnTimeout[0]		 = "Ready";
	stateSound[0]					= GunPlusEmptyClip;

	stateName[1]							= "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]			= true;
	stateSequence[1]	= "Ready";

	stateName[2]						  = "Fire";
	stateTransitionOnTimeout[2]	  = "Smoke";
	stateTimeoutValue[2]				= 0;
	stateFire[2]						  = true;
	stateAllowImageChange[2]		  = false;
	stateSequence[2]					 = "Fire";
	stateScript[2]						= "onFire";
	stateWaitForTimeout[2]			= false;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzlePoint";
	stateSound[2]					= GunPlusFireSound;
	stateEjectShell[2]		 = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzlePoint";
	stateTimeoutValue[3]				= 0;
	stateWaitForTimeout[3]			= true;
	stateTransitionOnTimeout[3]	  = "Wait";

	stateName[4]			= "Reload";
	stateSequence[4]					 = "Reload";
	stateTimeoutValue[4]				 = 1.15;
	stateWaitForTimeout[4]			= true;
	stateSound[4]					= GunPlusReloadSound;
	stateTransitionOnTimeout[4]	  = "Wait";
	
	stateName[5]			= "Wait";
	stateTimeoutValue[5]				 = 0.32;
	stateWaitForTimeout[5]			= true;
	stateTransitionOnTimeout[5]	  = "Ready";
};

datablock ShapeBaseImageData(GunPlusReloadImage : GunPlusImage)
{
	projectile = "";
	stateName[0]							= "Activate";
	stateTimeoutValue[0]				 = 0;
	stateWaitFortimeout[0]				= false;
	stateTransitionOnTimeout[0]		 = "Fire";
	
	stateName[2]						  = "Fire";
	stateTransitionOnTimeout[2]	  = "Reload";
	stateTimeoutValue[2]				= 0;
	stateFire[2]						  = false;
	stateAllowImageChange[2]		  = true;
	stateSequence[2]					 = "Fire";
	stateScript[2]						= "onComplete";
	stateWaitForTimeout[2]			= false;
	stateEmitter[2]					= "";
	stateEmitterTime[2]				= "";
	stateEmitterNode[2]				= "";
	stateSound[2]					= GunPlusEmptyClip;
	stateEjectShell[2]		 = false;
};

function GunPlusImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0 && $Pref::GunPlus::DoRecoil)
	{
		%obj.playThread(2, shiftAway);
	}
	bottomPrint(%obj.client, "<just:right><font:impact:25>\c3Ammo\c6: " @ %obj.GunPlusAmmo @ " / " @ $Pref::GunPlus::MaxClipAmmo, 2);
	if(%obj.GunPlusAmmo == 0)
	{
		%obj.unmountImage(%slot);
		%obj.mountImage(GunPlusReloadImage, %slot);
		%obj.GunPlusAmmo = $Pref::GunPlus::MaxClipAmmo;
	}
	else
	{
		Parent::onFire(%this,%obj,%slot);
		%obj.GunPlusAmmo--;
		if($Pref::GunPlus::PlayDistantSound)
		{
			serverPlay2D(GunPlusDistantFire);
		}
	}	
}

function GunPlusReloadImage::onComplete(%this,%obj,%slot)
{
	%obj.schedule(1200, unmountImage, %slot);
	%obj.schedule(1200, mountImage, GunPlusImage, %slot, true);
}

function GunPlusImage::onMount(%this,%obj,%slot,%reloaded)
{
	//%obj.hideNode("RHand");
	Parent::onMount(%this,%obj,%slot);
	if(%reloaded == true)
	{
		%obj.GunPlusAmmo = $Pref::GunPlus::MaxClipAmmo;
	}
}

function GunPlusImage::onUnMount(%this,%obj,%slot)
{
	//%obj.unHideNode("RHand");
	Parent::onUnMount(%this,%obj,%slot);	
}
